"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _changeCurrentInlineStyle = require("./changeCurrentInlineStyle");

var _changeCurrentInlineStyle2 = _interopRequireDefault(_changeCurrentInlineStyle);

var _constants = require("../constants");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var handleInlineStyle = function handleInlineStyle(editorState, character) {
  var key = editorState.getSelection().getStartKey();
  var text = editorState.getCurrentContent().getBlockForKey(key).getText();

  var line = "" + text + character;
  var newEditorState = editorState;

  Object.keys(_constants.inlineMatchers).some(function (k) {
    _constants.inlineMatchers[k].some(function (re) {
      var matchArr = void 0;
      do {
        matchArr = re.exec(line);
        if (matchArr) {
          newEditorState = (0, _changeCurrentInlineStyle2.default)(newEditorState, matchArr, k, character);
        }
      } while (matchArr);
      return newEditorState !== editorState;
    });
    return newEditorState !== editorState;
  });
  return newEditorState;
};

exports.default = handleInlineStyle;